<?php
// +----------------------------------------------------------------------
// | Leaps PHP Framework
// +----------------------------------------------------------------------
// | Copyright (c) 2010 http://www.newsteng.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: Silence <xutongle@gmail.com>
// +----------------------------------------------------------------------
// $Id$

/**
 +------------------------------------------------------------------------------
 * application.class.php Leaps 应用程序创建类
 +------------------------------------------------------------------------------
 * $Id$
 +------------------------------------------------------------------------------
 */
class application {
	/**
	 * 构造函数
	 */
	public function __construct() {
        Core::load_core_class('router','',0);
		router::dispatch();//加载路由配置
		self::check_language();
        G('init_time');
		$this->exec();
	}

	/**
	 * 加载控制器执行应用程序
	 * @param string $filename
	 * @param string $m
	 * @return obj
	 */
	private function exec() {
		$filename = ROUTE_C.'Controller';
		$filepath = BASE_PATH.'application'.DS.ROUTE_APP.DS.$filename.'.php';
		if (file_exists_case($filepath)) {
			Core::import($filepath);
			if(class_exists($filename)) $controller = new $filename;
			else throw_exception(ROUTE_APP.L('_APPLICATION_').$filename.L('_CONTROLLER_NOT_EXIST_'));
		} else {
			throw_exception(ROUTE_APP.L('_APPLICATION_NOT_EXIST_').L('_OR_').$filename.L('_CONTROLLER_NOT_EXIST_'));
		}
		if (method_exists($controller, ROUTE_A)) {
			if (preg_match('/^[_]/i', ROUTE_A)) {
            	throw_exception(ROUTE_A.L('_ACTION_IS_PRIVATE_'));
			} else {
				call_user_func(array($controller, ROUTE_A));
			}
		} else {
            throw_exception(ROUTE_A.L('_ACTION_NOT_EXIST_'));
		}
	}

	/**
	 * 根据配置设置语言包常量
	 */
	static private function check_language() {
        // 根据是否启用自动侦测设置获取语言选择
		if (Core::load_config('core','lang_auto')){
            if(isset($_GET[Core::load_config('core','var_language')])){// 检测浏览器支持语言
            	$lang_set = $_GET[Core::load_config('core','var_language')];// url中设置了语言变量
                cookie::set('language',$lang_set);
            }elseif(cookie::get('language'))// 获取上次用户的选择
                $lang_set = cookie::get('language');
            elseif(isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])){// 自动侦测浏览器语言
                preg_match('/^([a-z\-]+)/i', $_SERVER['HTTP_ACCEPT_LANGUAGE'], $matches);
                $lang_set = strtolower($matches[1]);
            }
			//判断语言是否被这支持
            if(strpos(Core::load_config('core','lang_all'), $lang_set)){
				define('LANG', $lang_set);
            }else{
				define('LANG', Core::load_config('core','lang'));
            }
        }else{
			define('LANG', Core::load_config('core','lang'));
        }
	}
}


/* End of file application.class.php */