<?php
// +----------------------------------------------------------------------
// | Leaps PHP Framework
// +----------------------------------------------------------------------
// | Copyright (c) 2010 http://www.newsteng.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: Silence <xutongle@gmail.com>
// +----------------------------------------------------------------------
// $Id$

/**
 +------------------------------------------------------------------------------
 * cookie.class.php Leaps Cookie处理类
 +------------------------------------------------------------------------------
 * $Id$
 +------------------------------------------------------------------------------
 */

class cookie {
	/**
	 * 判断Cookie是否存在
	 * @param string $var 变量名
	 * @return boolean 成功则返回true，否则返回 false
	 */
    public static function is_set($var) {
        return isset($_COOKIE[Core::load_config('core','cookie_pre').$var]);
    }

	/**
	 * 获取某个Cookie值
	 * @param string $var 变量名
 	 * @param string $default 默认值
 	 * @return mixed 成功则返回cookie 值，否则返回 false
	 */
    public static function get($var, $default = '') {
        $var = Core::load_config('core','cookie_pre').$var;
		return isset($_COOKIE[$var]) ? authcode($_COOKIE[$var], 'DECODE') : $default;
    }

    /**
 	 * 设置 cookie
 	 * @param string $var     变量名
 	 * @param string $value   变量值
 	 * @param int $time    过期时间
 	 */
    public static function set($var, $value = '', $time = 0) {
		$time = $time > 0 ? $time : ($value == '' ? TIME - 3600 : 0);
		$s = $_SERVER['SERVER_PORT'] == '443' ? 1 : 0;
		$var = Core::load_config('core','cookie_pre').$var;
		$_COOKIE[$var] = $value;
		setcookie($var, authcode($value, 'ENCODE'), $time, Core::load_config('core','cookie_path'), Core::load_config('core','cookie_domain'), $s);
	}

	/**
	 * 删除某个Cookie值
	 * @param string $var     变量名
	 */
    public static function delete($var) {
        Cookie::set($var,'',time()-3600);
        unset($_COOKIE[Core::load_config('core','cookie_pre').$var]);
    }

    /**
	 * 清空Cookie值
	 */
    public static function clear() {
        unset($_COOKIE);
    }

}

/* End of file cookie.class.php */