<?php
// +----------------------------------------------------------------------
// | Leaps PHP Framework
// +----------------------------------------------------------------------
// | Copyright (c) 2010 http://www.newsteng.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: Silence <xutongle@gmail.com>
// +----------------------------------------------------------------------
// $Id$

/**
 +------------------------------------------------------------------------------
 * param.class.php Leaps 参数处理类
 +------------------------------------------------------------------------------
 * $Id$
 +------------------------------------------------------------------------------
 */
class param {
	//路由配置
	private $route_config = '';

	public function __construct() {
		$this->route_config = Core::load_config('route', SITE_HOST) ? Core::load_config('route', SITE_HOST) : Core::load_config('route', 'default');

		if(isset($this->route_config['data']['POST']) && is_array($this->route_config['data']['POST'])) {
			foreach($this->route_config['data']['POST'] as $_key => $_value) {
				if(!isset($_POST[$_key])) $_POST[$_key] = $_value;
			}
		}
		if(isset($this->route_config['data']['GET']) && is_array($this->route_config['data']['GET'])) {
			foreach($this->route_config['data']['GET'] as $_key => $_value) {
				if(!isset($_GET[$_key])) $_GET[$_key] = $_value;
			}
		}
		if(isset($_GET['page'])) $_GET['page'] = max(intval($_GET['page']),1);
		return true;
	}

	/**
	 * 获取模型
	 */
	public function get_application() {
		$app = isset($_GET[Core::load_config('core','var_application')]) && !empty($_GET[Core::load_config('core','var_application')]) ? $_GET[Core::load_config('core','var_application')] : (isset($_POST[Core::load_config('core','var_application')]) && !empty($_POST[Core::load_config('core','var_application')]) ? $_POST[Core::load_config('core','var_application')] : '');
		if (empty($app)) {
			return $this->route_config['application'];
		} else {
			return $app;
		}
	}

	/**
	 * 获取控制器
	 */
	public function get_controller() {
		$c = isset($_GET[Core::load_config('core','var_controller')]) && !empty($_GET[Core::load_config('core','var_controller')]) ? $_GET[Core::load_config('core','var_controller')] : (isset($_POST[Core::load_config('core','var_controller')]) && !empty($_POST[Core::load_config('core','var_controller')]) ? $_POST[Core::load_config('core','var_controller')] : '');
		if (empty($c)) {
			return ucfirst($this->route_config['controller']);
		} else {
			return ucfirst($c);
		}
	}
	/**
	 * 获取事件
	 */
	public function get_action() {
		$a = isset($_GET[Core::load_config('core','var_action')]) && !empty($_GET[Core::load_config('core','var_action')]) ? $_GET[Core::load_config('core','var_action')] : (isset($_POST[Core::load_config('core','var_action')]) && !empty($_POST[Core::load_config('core','var_action')]) ? $_POST[Core::load_config('core','var_action')] : '');
		if (empty($a)) {
			return $this->route_config['action'];
		} else {
			return $a;
		}
	}
}

/* End of file param.class.php */