<?php
// +----------------------------------------------------------------------
// | Leaps PHP Framework
// +----------------------------------------------------------------------
// | Copyright (c) 2010 http://www.newsteng.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: Silence <xutongle@gmail.com>
// +----------------------------------------------------------------------
// $Id$

/**
 +------------------------------------------------------------------------------
 * router.class.php Leaps 路由调度类
 +------------------------------------------------------------------------------
 * $Id$
 +------------------------------------------------------------------------------
 */

class router {
	/**
     * URL映射到控制器
     */
	static public function dispatch() {
    	//$routes = Core::load_config('route', SITE_HOST) ? Core::load_config('route', SITE_HOST) : load_profile('route', 'default');
        $url_mode  =  Core::load_config('core','url_model');
		if(Core::load_config('core','url_model') == 2 ) {
            //当前项目地址
            $url    =   dirname(_PHP_FILE_);
            if($url == '/' || $url == '\\') $url    =   '';
            define('PHP_FILE',$url);
        }elseif(Core::load_config('core','url_model') == 3){
            define('PHP_FILE',_PHP_FILE_.'?'.Core::load_config('core','var_pathinfo').'=');
        }else{
        	 //当前项目地址
            define('PHP_FILE',_PHP_FILE_);
        }
        $depr = Core::load_config('core','url_pathinfo_depr');
        // 分析PATHINFO信息
        self::getPathInfo();
        if(!empty($_SERVER['PATH_INFO'])) {
            if(Core::load_config('core','url_html_suffix'))
                $_SERVER['PATH_INFO']   =   preg_replace('/\.'.Core::load_config('core','url_html_suffix').'$/','',$_SERVER['PATH_INFO']);
            $paths = explode($depr,trim($_SERVER['PATH_INFO'],'/'));
            $var  =  array();
            $var[Core::load_config('core','var_application')]  =   array_shift($paths);
            $var[Core::load_config('core','var_controller')]  =   array_shift($paths);
            $var[Core::load_config('core','var_action')]  =   array_shift($paths);
            // 解析剩余的URL参数
            preg_replace('@(\w+)'.$depr.'([^\/]+)@e', '$var[\'\\1\']="\\2";', implode($depr,$paths));
            $_GET   =  array_merge($var,$_GET);
        }
		//保证$_REQUEST正常取值
        $_REQUEST = array_merge($_POST,$_GET);
		//进入参数处理流程
		$param = Core::load_core_class('param');
        define('ROUTE_APP',$param->get_application());
        define('ROUTE_C',$param->get_controller());
        define('ROUTE_A',$param->get_action());
        define('APP',Core::load_config('core','var_application'));
        define('CONTROLLER',Core::load_config('core','var_controller'));
        define('ACTION',Core::load_config('core','var_action'));
    }

	/**
    * 获得服务器的PATH_INFO信息
    * @access public
    * @return void
    */
    public static function getPathInfo() {
         if(!empty($_GET[Core::load_config('core','var_pathinfo')])) {//兼容模式
            $path = $_GET[Core::load_config('core','var_pathinfo')];// 兼容PATHINFO 参数
            unset($_GET[Core::load_config('core','var_pathinfo')]);
        } elseif(!empty($_SERVER['PATH_INFO'])) { //PATH_INFO模式
            $pathInfo = $_SERVER['PATH_INFO'];
            if(0 === strpos($pathInfo,$_SERVER['SCRIPT_NAME'])) $path = substr($pathInfo, strlen($_SERVER['SCRIPT_NAME']));
            else $path = $pathInfo;
        } elseif(!empty($_SERVER['ORIG_PATH_INFO'])) {
            $pathInfo = $_SERVER['ORIG_PATH_INFO'];
            if(0 === strpos($pathInfo, $_SERVER['SCRIPT_NAME']))
                $path = substr($pathInfo, strlen($_SERVER['SCRIPT_NAME']));
            else
                $path = $pathInfo;
        } elseif (!empty($_SERVER['REDIRECT_PATH_INFO'])) {
            $path = $_SERVER['REDIRECT_PATH_INFO'];
        } elseif(!empty($_SERVER["REDIRECT_Url"])) {
            $path = $_SERVER["REDIRECT_Url"];
            if(empty($_SERVER['QUERY_STRING']) || $_SERVER['QUERY_STRING'] == $_SERVER["REDIRECT_QUERY_STRING"]) {
                $parsedUrl = parse_url($_SERVER["REQUEST_URI"]);
                if(!empty($parsedUrl['query'])) {
                    $_SERVER['QUERY_STRING'] = $parsedUrl['query'];
                    parse_str($parsedUrl['query'], $GET);
                    $_GET = array_merge($_GET, $GET);
                    reset($_GET);
                } else {
                    unset($_SERVER['QUERY_STRING']);
                }
                reset($_SERVER);
            }
        }
        if(Core::load_config('core','url_html_suffix') && !empty($path)) {
            $suffix =   substr(Core::load_config('core','url_html_suffix'),1);
            $path   =   preg_replace('/\.'.$suffix.'$/','',$path);
        }
        $_SERVER['PATH_INFO'] = empty($path) ? '/' : $path;
    }
}

/* End of file router.class.php */