<?php
// +----------------------------------------------------------------------
// | Leaps PHP Framework
// +----------------------------------------------------------------------
// | Copyright (c) 2010 http://www.newsteng.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: Silence <xutongle@gmail.com>
// +----------------------------------------------------------------------
// $Id$

/**
 +------------------------------------------------------------------------------
 * view.class.php Leaps
 +------------------------------------------------------------------------------
 * $Id$
 +------------------------------------------------------------------------------
 */

class view {

	/**
	 * 编译视图
	 *
	 * @param $application	应用名称
	 * @param $template	视图文件名
	 * @param $istag	是否为标签模板
	 * @return unknown
	 */

	public function compile($application, $template, $style = 'default') {
		$tplfile = BASE_PATH.'view'.DS.$style.DS.$application.DS.$template.Core::load_config('core','tpl_suffix');
		if ($style != 'default' && !file_exists ( $tplfile )) {
			$style = 'default';
			$tplfile = BASE_PATH.'view'.DS.'default'.DS.$application.DS.$template.Core::load_config('core','tpl_suffix');
		}
		if (! file_exists ( $tplfile )) throw_exception(BASE_PATH.Core::load_config('core','tpl_root').DS.$style.DS.$application.DS.$template.Core::load_config('core','tpl_suffix').L('_FILE_NOT_EXIST_'));
		$filepath = CACHE_PATH.'view'.DS.$style.DS.$application.DS;
	    if(!is_dir($filepath)) mkdir($filepath, 0777, true);
		$compiledtplfile = $filepath.$template.'.php';
		return $this->refresh($tplfile,$compiledtplfile);
	}

	/**
	 * 更新视图缓存
	 *
	 * @param string $tplfile	视图原文件路径
	 * @param string $compiledtplfile	编译完成后，写入文件名
	 * @return int $strlen 长度
	 */
	public function refresh($tplfile, $compiledtplfile) {
		$str = @file_get_contents ($tplfile);
		$str = $this->parse ($str,$compiledtplfile);
		$strlen = file_put_contents ($compiledtplfile, $str );
		chmod ($compiledtplfile, 0777);
		return $strlen;
	}


	/**
	 * 解析视图
	 *
	 * @param string $str	视图内容
	 * @return ture
	 */
	public function parse($str,$compiledtplfile) {
		$str = preg_replace ( "/\{template\s+(.+)\}/", "<?php include template(\\1); ?>", $str );
		$str = preg_replace ( "/\{include\s+(.+)\}/", "<?php include \\1; ?>", $str );
		$str = preg_replace ( "/\{php\s+(.+)\}/", "<?php \\1?>", $str );
		$str = preg_replace ( "/\{if\s+(.+?)\}/", "<?php if(\\1) { ?>", $str );
		$str = preg_replace ( "/\{else\}/", "<?php } else { ?>", $str );
		$str = preg_replace ( "/\{elseif\s+(.+?)\}/", "<?php } elseif (\\1) { ?>", $str );
		$str = preg_replace ( "/\{\/if\}/", "<?php } ?>", $str );
		//for 循环
		$str = preg_replace("/\{for\s+(.+?)\}/","<?php for(\\1) { ?>",$str);
		$str = preg_replace("/\{\/for\}/","<?php } ?>",$str);
		//++ --
		$str = preg_replace("/\{\+\+(.+?)\}/","<?php ++\\1; ?>",$str);
		$str = preg_replace("/\{\-\-(.+?)\}/","<?php ++\\1; ?>",$str);
		$str = preg_replace("/\{(.+?)\+\+\}/","<?php \\1++; ?>",$str);
		$str = preg_replace("/\{(.+?)\-\-\}/","<?php \\1--; ?>",$str);
		$str = preg_replace ( "/\{loop\s+(\S+)\s+(\S+)\}/", "<?php \$n=1;if(is_array(\\1)) foreach(\\1 AS \\2) { ?>", $str );
		$str = preg_replace ( "/\{loop\s+(\S+)\s+(\S+)\s+(\S+)\}/", "<?php \$n=1; if(is_array(\\1)) foreach(\\1 AS \\2 => \\3) { ?>", $str );
		$str = preg_replace ( "/\{\/loop\}/", "<?php \$n++;}unset(\$n); ?>", $str );
		$str = preg_replace ( "/\{([a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff:]*\(([^{}]*)\))\}/", "<?php echo \\1;?>", $str );
		$str = preg_replace ( "/\{\\$([a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff:]*\(([^{}]*)\))\}/", "<?php echo \\1;?>", $str );
		$str = preg_replace ( "/\{(\\$[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*)\}/", "<?php echo \\1;?>", $str );
		$str = preg_replace("/\{(\\$[a-zA-Z0-9_\[\]\'\"\$\x7f-\xff]+)\}/es", "\$this->addquote('<?php echo \\1;?>')",$str);
		$str = preg_replace ( "/\{([A-Z_\x7f-\xff][A-Z0-9_\x7f-\xff]*)\}/s", "<?php echo \\1;?>", $str );
		$str = "<?php defined('IN_LEAPS') or exit('No permission resources.'); ?>" . $str;
		if(Core::load_config('core','show_page_trace'))$str = preg_replace ( "/\<\/body\>/", "<?php echo show_trace('$compiledtplfile'); ?></body>", $str );
		$str = preg_replace ( "/\<\/body\>/", "<?php echo base64_decode('PCEtLUxlYXBzIFBIUCBGcmFtZXdvcmsg5piv5LiA5Liq5oCn6IO95Y2T6LaK5bm25LiU5Yqf6IO95Liw5a+M55qE6L276YeP57qnUEhQ5byA5Y+R5qGG5p6277yM5a6X5peo5bCx5piv6K6pV0VC5bqU55So5byA5Y+R5pu0566A5Y2V44CB5pu05b+r6YCf44CCTGVhcHMgUEhQIEZyYW1ld29ya+eahOWumOaWuee9keermeaYr2h0dHA6Ly9sZWFwcy5uZXdzdGVuZy5jb20gLS0+');?></body>", $str );
		return $str;
	}

	/**
	 * 转义 // 为 /
	 *
	 * @param string $var	转义的字符
	 * @return 转义后的字符
	 */
	public function addquote($var) {
		return str_replace ( "\\\"", "\"", preg_replace ( "/\[([a-zA-Z0-9_\-\.\x7f-\xff]+)\]/s", "['\\1']", $var ) );
	}

	/**
	 * 转换数据为HTML代码
	 *
	 * @param array $data 数组
	 */
	private static function arr_to_html($data) {
		if (is_array($data)) {
			$str = 'array(';
			foreach ($data as $key=>$val) {
				if (is_array($val)) {
					$str .= "'$key'=>".self::arr_to_html($val).",";
				} else {
					if (strpos($val, '$')===0) {
						$str .= "'$key'=>$val,";
					} else {
						$str .= "'$key'=>'".new_addslashes($val)."',";
					}
				}
			}
			return $str.')';
		}
		return false;
	}
}

/* End of file view.class.php */