<?php
// +----------------------------------------------------------------------
// | Leaps PHP Framework
// +----------------------------------------------------------------------
// | Copyright (c) 2010 http://www.newsteng.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: Silence <xutongle@gmail.com>
// +----------------------------------------------------------------------
// $Id$

/**
 +------------------------------------------------------------------------------
 * global.func.php Leaps 通用函数库
 +------------------------------------------------------------------------------
 * $Id$
 +------------------------------------------------------------------------------
 */
/**
 * 判断是否是AJAX请求（仅支持Jquery）
 */
function is_ajax() {
	if(isset($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'XMLHttpRequest') return true;
	else return false;
}

/**
 * 记录访问日志
 */
function access_log(){
	if(Core::load_config('core','access_log')) {//记录系统访问日志
		$str ="\nREQUEST_URI:http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']."\n";
		$str.='REMOTE_ADDR:'.$_SERVER['REMOTE_ADDR']."\n";
		$str.=isset($_SERVER['HTTP_USER_AGENT']) ? 'HTTP_USER_AGENT:'.$_SERVER['HTTP_USER_AGENT']."\n" : '';
		$str.='------------------------------';
		wlog('AccessLog-'.date('Y-m-d').'.log', '['. date('H:i:s') .']'.$str);
	}
	return true;
}

/**
 * 字符串截取，支持中文和其他编码
 *
 * @param string $str 需要截取的字符串
 * @param int $length 截取长度
 * @param int $start 开始位置
 * @param string $charset 编码格式
 * @param string $suffix 截断显示字符
 * @return string
 */
function str_cut($str, $length, $start=0, $charset="utf-8", $suffix='...') {
    if(function_exists("mb_substr")) return mb_substr($str, $start, $length, $charset);
    elseif(function_exists('iconv_substr')) return iconv_substr($str,$start,$length,$charset);
    $re['utf-8']   = "/[\x01-\x7f]|[\xc2-\xdf][\x80-\xbf]|[\xe0-\xef][\x80-\xbf]{2}|[\xf0-\xff][\x80-\xbf]{3}/";
    $re['gb2312'] = "/[\x01-\x7f]|[\xb0-\xf7][\xa0-\xfe]/";
    $re['gbk']    = "/[\x01-\x7f]|[\x81-\xfe][\x40-\xfe]/";
    $re['big5']   = "/[\x01-\x7f]|[\x81-\xfe]([\x40-\x7e]|\xa1-\xfe])/";
    preg_match_all($re[$charset], $str, $match);
    $slice = join("",array_slice($match[0], $start, $length));
    if($suffix) return $slice.$suffix;
    return $slice;
}

/**
 * 产生随机字串，可用来自动生成密码 默认长度6位 字母和数字混合
 *
 * @param int $len 长度
 * @param int $type 字串类型 0 字母 1 数字 2 大写字母 3 小写字母  4中文  其它 混合
 * @param string $addChars 额外字符
 * @return string
 */
function random($len=6,$type='',$addChars='') {
    $str ='';
    switch($type) {
        case 0:
            $chars='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.$addChars;
            break;
        case 1:
            $chars= str_repeat('0123456789',3);
            break;
        case 2:
            $chars='ABCDEFGHIJKLMNOPQRSTUVWXYZ'.$addChars;
            break;
        case 3:
            $chars='abcdefghijklmnopqrstuvwxyz'.$addChars;
            break;
        case 4:
            $chars = "们以我到他会作时要动国产的一是工就年阶义发成部民可出能方进在了不和有大这主中人上为来分生对于学下级地个用同行面说种过命度革而多子后自社加小机也经力线本电高量长党得实家定深法表着水理化争现所二起政三好十战无农使性前等反体合斗路图把结第里正新开论之物从当两些还天资事队批点育重其思与间内去因件日利相由压员气业代全组数果期导平各基或月毛然如应形想制心样干都向变关问比展那它最及外没看治提五解系林者米群头意只明四道马认次文通但条较克又公孔领军流入接席位情运器并飞原油放立题质指建区验活众很教决特此常石强极土少已根共直团统式转别造切九你取西持总料连任志观调七么山程百报更见必真保热委手改管处己将修支识病象几先老光专什六型具示复安带每东增则完风回南广劳轮科北打积车计给节做务被整联步类集号列温装即毫知轴研单色坚据速防史拉世设达尔场织历花受求传口断况采精金界品判参层止边清至万确究书术状厂须离再目海交权且儿青才证低越际八试规斯近注办布门铁需走议县兵固除般引齿千胜细影济白格效置推空配刀叶率述今选养德话查差半敌始片施响收华觉备名红续均药标记难存测士身紧液派准斤角降维板许破述技消底床田势端感往神便贺村构照容非搞亚磨族火段算适讲按值美态黄易彪服早班麦削信排台声该击素张密害侯草何树肥继右属市严径螺检左页抗苏显苦英快称坏移约巴材省黑武培著河帝仅针怎植京助升王眼她抓含苗副杂普谈围食射源例致酸旧却充足短划剂宣环落首尺波承粉践府鱼随考刻靠够满夫失包住促枝局菌杆周护岩师举曲春元超负砂封换太模贫减阳扬江析亩木言球朝医校古呢稻宋听唯输滑站另卫字鼓刚写刘微略范供阿块某功套友限项余倒卷创律雨让骨远帮初皮播优占死毒圈伟季训控激找叫云互跟裂粮粒母练塞钢顶策双留误础吸阻故寸盾晚丝女散焊功株亲院冷彻弹错散商视艺灭版烈零室轻血倍缺厘泵察绝富城冲喷壤简否柱李望盘磁雄似困巩益洲脱投送奴侧润盖挥距触星松送获兴独官混纪依未突架宽冬章湿偏纹吃执阀矿寨责熟稳夺硬价努翻奇甲预职评读背协损棉侵灰虽矛厚罗泥辟告卵箱掌氧恩爱停曾溶营终纲孟钱待尽俄缩沙退陈讨奋械载胞幼哪剥迫旋征槽倒握担仍呀鲜吧卡粗介钻逐弱脚怕盐末阴丰雾冠丙街莱贝辐肠付吉渗瑞惊顿挤秒悬姆烂森糖圣凹陶词迟蚕亿矩康遵牧遭幅园腔订香肉弟屋敏恢忘编印蜂急拿扩伤飞露核缘游振操央伍域甚迅辉异序免纸夜乡久隶缸夹念兰映沟乙吗儒杀汽磷艰晶插埃燃欢铁补咱芽永瓦倾阵碳演威附牙芽永瓦斜灌欧献顺猪洋腐请透司危括脉宜笑若尾束壮暴企菜穗楚汉愈绿拖牛份染既秋遍锻玉夏疗尖殖井费州访吹荣铜沿替滚客召旱悟刺脑措贯藏敢令隙炉壳硫煤迎铸粘探临薄旬善福纵择礼愿伏残雷延烟句纯渐耕跑泽慢栽鲁赤繁境潮横掉锥希池败船假亮谓托伙哲怀割摆贡呈劲财仪沉炼麻罪祖息车穿货销齐鼠抽画饲龙库守筑房歌寒喜哥洗蚀废纳腹乎录镜妇恶脂庄擦险赞钟摇典柄辩竹谷卖乱虚桥奥伯赶垂途额壁网截野遗静谋弄挂课镇妄盛耐援扎虑键归符庆聚绕摩忙舞遇索顾胶羊湖钉仁音迹碎伸灯避泛亡答勇频皇柳哈揭甘诺概宪浓岛袭谁洪谢炮浇斑讯懂灵蛋闭孩释乳巨徒私银伊景坦累匀霉杜乐勒隔弯绩招绍胡呼痛峰零柴簧午跳居尚丁秦稍追梁折耗碱殊岗挖氏刃剧堆赫荷胸衡勤膜篇登驻案刊秧缓凸役剪川雪链渔啦脸户洛孢勃盟买杨宗焦赛旗滤硅炭股坐蒸凝竟陷枪黎救冒暗洞犯筒您宋弧爆谬涂味津臂障褐陆啊健尊豆拔莫抵桑坡缝警挑污冰柬嘴啥饭塑寄赵喊垫丹渡耳刨虎笔稀昆浪萨茶滴浅拥穴覆伦娘吨浸袖珠雌妈紫戏塔锤震岁貌洁剖牢锋疑霸闪埔猛诉刷狠忽灾闹乔唐漏闻沈熔氯荒茎男凡抢像浆旁玻亦忠唱蒙予纷捕锁尤乘乌智淡允叛畜俘摸锈扫毕璃宝芯爷鉴秘净蒋钙肩腾枯抛轨堂拌爸循诱祝励肯酒绳穷塘燥泡袋朗喂铝软渠颗惯贸粪综墙趋彼届墨碍启逆卸航衣孙龄岭骗休借".$addChars;
            break;
        default :
            // 默认去掉了容易混淆的字符oOLl和数字01，要添加请使用addChars参数
            $chars='ABCDEFGHIJKMNPQRSTUVWXYZabcdefghijkmnpqrstuvwxyz23456789'.$addChars;
            break;
    }
	if($len>10 ) {//位数过长重复字符串一定次数
        $chars= $type==1 ? str_repeat($chars,$len) : str_repeat($chars,5);
    }
	if($type!=4) {
        $chars   =   str_shuffle($chars);
        $str     =   substr($chars,0,$len);
    } else {
        // 中文随机字
        for($i=0;$i<$len;$i++){
          $str.= str_cut($chars,1, floor(mt_rand(0,mb_strlen($chars,'utf-8')-1)),$charset="utf-8",'');
        }
    }
    return $str;
}

/**
 * 发送HTTP状态信息
 *
 * @param int $code 状态代码
 */
function send_http_status($code) {
    static $_status = array(
        // Informational 1xx
        100 => 'Continue',
        101 => 'Switching Protocols',
        // Success 2xx
        200 => 'OK',
        201 => 'Created',
        202 => 'Accepted',
        203 => 'Non-Authoritative Information',
        204 => 'No Content',
        205 => 'Reset Content',
        206 => 'Partial Content',
        // Redirection 3xx
        300 => 'Multiple Choices',
        301 => 'Moved Permanently',
        302 => 'Moved Temporarily ',  // 1.1
        303 => 'See Other',
        304 => 'Not Modified',
        305 => 'Use Proxy',
        // 306 is deprecated but reserved
        307 => 'Temporary Redirect',
        // Client Error 4xx
        400 => 'Bad Request',
        401 => 'Unauthorized',
        402 => 'Payment Required',
        403 => 'Forbidden',
        404 => 'Not Found',
        405 => 'Method Not Allowed',
        406 => 'Not Acceptable',
        407 => 'Proxy Authentication Required',
        408 => 'Request Timeout',
        409 => 'Conflict',
        410 => 'Gone',
        411 => 'Length Required',
        412 => 'Precondition Failed',
        413 => 'Request Entity Too Large',
        414 => 'Request-URI Too Long',
        415 => 'Unsupported Media Type',
        416 => 'Requested Range Not Satisfiable',
        417 => 'Expectation Failed',
        // Server Error 5xx
        500 => 'Internal Server Error',
        501 => 'Not Implemented',
        502 => 'Bad Gateway',
        503 => 'Service Unavailable',
        504 => 'Gateway Timeout',
        505 => 'HTTP Version Not Supported',
        509 => 'Bandwidth Limit Exceeded'
    );
    if(array_key_exists($code,$_status)) header('HTTP/1.1 '.$code.' '.$_status[$code]);
}

/**
 * 查询字符是否存在于某字符串
 *
 * @param string $haystack 字符串
 * @param string $needle 要查找的字符
 * @return bool
 */
function str_exists($haystack, $needle) {
	return !(strpos($haystack, $needle) === FALSE);
}

/**
 * 取得文件扩展名
 *
 * @param string $filename 文件名
 * @return 扩展名
 */
function fileext($filename) {
	return strtolower(trim(substr(strrchr($filename, '.'), 1, 10)));
}

/**
 * IE浏览器判断
 */
function is_ie() {
	$useragent = strtolower($_SERVER['HTTP_USER_AGENT']);
	if((strpos($useragent, 'opera') !== false) || (strpos($useragent, 'konqueror') !== false)) return false;
	if(strpos($useragent, 'msie ') !== false) return true;
	return false;
}

/**
 * 检查字符串是否是UTF8编码。
 *
 * @param string $string 要被检查的字符串
 */
function is_utf8($string) {
	return preg_match('%^(?:
		 [\x09\x0A\x0D\x20-\x7E]            # ASCII
	   | [\xC2-\xDF][\x80-\xBF]             # non-overlong 2-byte
	   |  \xE0[\xA0-\xBF][\x80-\xBF]        # excluding overlongs
	   | [\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}  # straight 3-byte
	   |  \xED[\x80-\x9F][\x80-\xBF]        # excluding surrogates
	   |  \xF0[\x90-\xBF][\x80-\xBF]{2}     # planes 1-3
	   | [\xF1-\xF3][\x80-\xBF]{3}          # planes 4-15
	   |  \xF4[\x80-\x8F][\x80-\xBF]{2}     # plane 16
   )*$%xs', $string);
}

/**
 * 全局缓存读取，默认为文件缓存，不加载缓存配置。
 *
 * @param string $name 缓存名称
 * @param string $filepath 数据路径（模块名称） cache/$filepath/
 * @param string $type 缓存类型
 * @param string $config 配置名称
 */
function S($name, $filepath='', $type='file', $config='') {
    Core::load_core_class('cache_factory','',0);
    //取得缓存对象实例
	if($config) {
		$cacheconfig = Core::load_config('cache');
		$cache = cache_factory::get_instance($cacheconfig)->get_cache($config);
	} else {
		$cache = cache_factory::get_instance()->get_cache($type);
	}
	N('cache_read',1);
	return $cache->get($name, '', '', $filepath);
}

/**
 * 全局缓存信息读取，默认为文件缓存，不加载缓存配置。
 *
 * @param string $name 缓存名称
 * @param string $filepath 数据路径（模块名称） cache/$filepath/
 * @param string $type 缓存类型
 * @param string $config 配置名称
 */
function SC($name, $filepath='', $type='file', $config='') {
    Core::load_core_class('cache_factory','',0);
	if($config) {
		$cacheconfig = Core::load_config('cache');
		$cache = cache_factory::get_instance($cacheconfig)->get_cache($config);
	} else $cache = cache_factory::get_instance()->get_cache($type);
	N('cache_read',1);
	return $cache->cacheinfo($name, '', '', $filepath);
}

/**
 * 全局缓存写入和删除
 *
 * @param string $name 缓存名称
 * @param array $data 缓存数据
 * @param string $filepath 数据路径（模块名称） cache/$filepath/
 * @param string $type 缓存类型[file,memcache,apc]
 * @param string $config 配置名称
 * @param int $timeout 过期时间
 */
function C($name, $data, $filepath='', $type='file', $config='', $timeout='') {
	Core::load_core_class('cache_factory','',0);
	if($config) {
		$cacheconfig = Core::load_config('cache');
		$cache = cache_factory::get_instance($cacheconfig)->get_cache($config);
	} else $cache = cache_factory::get_instance()->get_cache($type);
	N('cache_write',1);
	if(empty($data)) {
		return $cache->delete($name, '', '', $filepath);
	}
	return $cache->set($name, $data, $timeout, '', $filepath);
}

/**
 * 将字符串转换为数组
 *
 * @param	string	$data	字符串
 * @return	array	返回数组格式，如果，data为空，则返回空数组
 */
function string2array($data) {
	if($data == '') return array();
	eval("\$array = $data;");
	return $array;
}

/**
 * 将数组转换为字符串
 *
 * @param	array	$data		数组
 * @param	bool	$isformdata	如果为0，则不使用new_stripslashes处理，可选参数，默认为1
 * @return	string	返回字符串，如果，data为空，则返回空
 */
function array2string($data, $isformdata = 1) {
	if($data == '') return '';
	if($isformdata) $data = new_stripslashes($data);
	return addslashes(var_export($data, TRUE));
}

/**
 * 显示运行时间、数据库操作、缓存次数、内存使用信息
 *
 * @return string
 */
 function showTime() {
 	$show_time= '';
    // 显示运行时间
    if(Core::load_config('core','show_run_time')) $show_time   =   'Process: '.G('begin_time','view_end_time').'s ';
    if(Core::load_config('core','show_adv_time')) $show_time .= '( Load:'.G('begin_time','load_time').'s Init:'.G('load_time','init_time').'s Exec:'.G('init_time','view_start_time').'s Template:'.G('view_start_time','view_end_time').'s )';
    if(Core::load_config('core','show_db_time') && class_exists('db_factory',false) ) $show_time .= ' | DB :'.N('db_query').' queries ';
    if(Core::load_config('core','show_cache_time')) $show_time .= ' | Cache :'.N('cache_read').' gets '.N('cache_write').' writes ';
    if(MEMORY_LIMIT_ON && Core::load_config('core','show_use_mem')) {
        // 显示内存开销
        $startMem    =  array_sum(explode(' ', $GLOBALS['_startusemems']));
        $endMem     =  array_sum(explode(' ', memory_get_usage()));
        $show_time .= ' | UseMem:'. number_format(($endMem - $startMem)/1024).' kb';
    }
    $show_time = '<div style="text-align:center; width:95%;font-size:8pt;color:#666;">'.$show_time.'</div>';
    return $show_time;
}

/**
 * 显示页面Trace信息
 */
function show_trace($compiledtplfile){
	// 显示页面Trace信息
    // 定义格式 return array('当前页面'=>$_SERVER['PHP_SELF'],'通信协议'=>$_SERVER['SERVER_PROTOCOL'],...);
    $_trace = array();
    $_trace['当前页面'] = $_SERVER['REQUEST_URI'];
	$_trace['模板缓存'] = $compiledtplfile;
	$_trace['请求方法'] = $_SERVER['REQUEST_METHOD'];
	$_trace['通信协议'] = $_SERVER['SERVER_PROTOCOL'];
	$_trace['请求时间'] = date('Y-m-d H:i:s',$_SERVER['REQUEST_TIME']);
	$_trace['用户代理'] = $_SERVER['HTTP_USER_AGENT'];
	$_trace['会话ID'] = session_id();
    $files =  get_included_files();
    $_trace['加载文件'] = count($files).str_replace("\n",'<br/>',substr(substr(print_r($files,true),7),0,-2));
    include CORE_PATH.'tpl'.DS.'trace.tpl.php';
}

/**
 * 系统视图类
 *
 * @param string $$application 应用名称
 * @param string $template 模版名称
 * @param string $style 视图风格名称
 */
function V($application = 'index', $template = 'index', $style = '') {
	G('view_start_time');
	if(!empty($style) && preg_match('/([a-z0-9\-_]+)/is',$style)){
	} elseif(empty($style)) $style = Core::load_config('core','tpl_name');
	if(!$style) $style = 'default';
	$view_cache = Core::load_core_class('view');
	//视图缓存路径
	$compiledtplfile = CACHE_PATH.'view'.DS.$style.DS.$application.DS.$template.'.php';
	if(defined('DEV')) $view_cache->compile($application, $template, 'default');
	//判断模版修改时间是否大于缓存修改时间如果大于重新编译模版
	if(file_exists(BASE_PATH.'view'.DS.$style.DS.$application.DS.$template.Core::load_config('core','tpl_suffix'))) {
		if(!file_exists($compiledtplfile) || (@filemtime(BASE_PATH.'view'.DS.$style.DS.$application.DS.$template.Core::load_config('core','tpl_suffix')) > @filemtime($compiledtplfile))) {
			$view_cache->compile($application, $template, $style);
		}
	} else {
		$compiledtplfile = CACHE_PATH.'view'.DS.'default'.DS.$application.DS.$template.'.php';
		if(file_exists($compiledtplfile) || (file_exists(BASE_PATH.'view'.DS.'default'.DS.$application.DS.$template.Core::load_config('core','tpl_suffix')) && filemtime(BASE_PATH.'view'.DS.'default'.DS.$application.DS.$template.Core::load_config('core','tpl_suffix')) > filemtime($compiledtplfile))){
			$view_cache->compile($application, $template, 'default');
		}elseif (!file_exists(BASE_PATH.'view'.DS.'default'.DS.$application.DS.$template.Core::load_config('core','tpl_suffix'))) {
			throw_exception(BASE_PATH.'view'.DS.$style.DS.$application.DS.$template.Core::load_config('core','tpl_suffix').L('_FILE_NOT_EXIST_'));
		}
	}
	G('view_end_time');
	return $compiledtplfile;
}

/**
 * 浏览器友好变量输出
 * @param $data 要输出的变量
 * @param $echo 是否输出
 */
function dump($var, $echo=true,$label=null, $strict=true) {
    $label = ($label===null) ? '' : rtrim($label) . ' ';
    if(!$strict) {
        if (ini_get('html_errors')) {
            $output = print_r($var, true);
            $output = "<pre>".$label.htmlspecialchars($output,ENT_QUOTES)."</pre>";
        } else {
            $output = $label . print_r($var, true);
        }
    }else {
        var_dump($var);
        $output = ob_get_clean();
        if(!extension_loaded('xdebug')) {
            $output = preg_replace("/\]\=\>\n(\s+)/m", "] => ", $output);
            $output = '<pre>'. $label. htmlspecialchars($output, ENT_QUOTES). '</pre>';
        }
    }
    if ($echo) {
        echo($output);
        return null;
    }else
        return $output;
}

/**
 * 生成sql语句，如果传入$in_cloumn 生成格式为 IN('a', 'b', 'c')
 * @param $data 条件数组或者字符串
 * @param $front 连接符
 * @param $in_column 字段名称
 * @return string
 */
function to_sqls($data, $front = ' AND ', $in_column = false) {
	if($in_column && is_array($data)) {
		$ids = '\''.implode('\',\'', $data).'\'';
		$sql = "$in_column IN ($ids)";
		return $sql;
	} else {
		if ($front == '') $front = ' AND ';
		if(is_array($data) && count($data) > 0) {
			$sql = '';
			foreach ($data as $key => $val) {
				$sql .= $sql ? " $front `$key` = '$val' " : " `$key` = '$val' ";
			}
			return $sql;
		} else {
			return $data;
		}
	}
}

/**
 * 获取当前页面完整URL地址
 */
function get_url() {
	$sys_protocal = isset($_SERVER['SERVER_PORT']) && $_SERVER['SERVER_PORT'] == '443' ? 'https://' : 'http://';
	$php_self = $_SERVER['PHP_SELF'] ? safe_replace($_SERVER['PHP_SELF']) : safe_replace($_SERVER['SCRIPT_NAME']);
	$path_info = isset($_SERVER['PATH_INFO']) ? safe_replace($_SERVER['PATH_INFO']) : '';
	$relate_url = isset($_SERVER['REQUEST_URI']) ? safe_replace($_SERVER['REQUEST_URI']) : $php_self.(isset($_SERVER['QUERY_STRING']) ? '?'.safe_replace($_SERVER['QUERY_STRING']) : $path_info);
	return $sys_protocal.(isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : '').$relate_url;
}

/**
 * URL路径解析，pages 函数的辅助函数
 *
 * @param string $par 传入需要解析的变量 默认为，page={$page}
 * @param string $url URL地址
 * @return URL
 */
function url_par($par, $url = '') {
	if($url == '') $url = get_url();
	if(!defined('IN_ADMIN') && $par != 'page={$page}') {
		$url = PHP_FILE;
		foreach ($_GET as $key => $val){
			if($key == Core::load_config('core','var_application') || $key == Core::load_config('core','var_controller') || $key == Core::load_config('core','var_action')) {
				$url .= Core::load_config('core','url_pathinfo_depr')."$val";
			} elseif($key != 'page') {
				$url .= Core::load_config('core','url_pathinfo_depr')."$key".Core::load_config('core','url_pathinfo_depr')."$val";
			}
		}
		$url .= Core::load_config('core','url_pathinfo_depr').$par.Core::load_config('core','url_html_suffix');
	} else {
		$pos = strpos($url, '?');
		if($pos === false) {
			$url .= '?'.$par;
		} else {
			$querystring = substr(strstr($url, '?'), 1);
			parse_str($querystring, $pars);
			$query_array = array();
			foreach($pars as $k=>$v) {
				if($k == 'page') continue;
				$query_array[$k] = $v;
			}
			$querystring = http_build_query($query_array).'&'.$par;
			$url = substr($url, 0, $pos).'?'.$querystring;
		}
	}
	return $url;
}

/**
 * 返回分页路径
 *
 * @param string $urlrule 分页规则
 * @param int $page 当前页
 * @param array $array 需要传递的数组，用于增加额外的方法
 * @return 完整的URL路径
 */
function pageurl($urlrule, $page, $array = array()) {
	if(strpos($urlrule, '~')) {
		$urlrules = explode('~', $urlrule);
		$urlrule = $page < 2 ? $urlrules[0] : $urlrules[1];
	}
	$findme = array('{$page}');
	$replaceme = array($page);
	if (is_array($array)) foreach ($array as $k=>$v) {
		$findme[] = '{$'.$k.'}';
		$replaceme[] = $v;
	}
	$url = str_replace($findme, $replaceme, $urlrule);
	$url = str_replace(array('http://','//','~'), array('~','/','http://'), $url);
	return $url;
}

/**
 * 分页函数
 *
 * @param int $num 信息总数
 * @param int $curr_page 当前分页
 * @param int $perpage 每页显示数
 * @param string $urlrule URL规则
 * @param array $array 需要传递的数组，用于增加额外的方法
 * @return 分页
 */
function pages($num, $curr_page, $perpage = 20, $urlrule = '', $array = array(),$setpages = 10) {
	if(defined('URLRULE')) {
		$urlrule = URLRULE;
		$array = $GLOBALS['URL_ARRAY'];
	} elseif(!defined('IN_ADMIN') && Core::load_config('core','url_model')> 0) {
		$urlrule = url_par('page'.Core::load_config('core','url_pathinfo_depr').'{$page}');
	} elseif($urlrule == '') {
		$urlrule = url_par('page={$page}');
	}
	$multipage = '';
	if($num > $perpage) {
		$page = $setpages+1;
		$offset = ceil($setpages/2-1);
		$pages = ceil($num / $perpage);
		if (defined('IN_ADMIN') && !defined('PAGES')) define('PAGES', $pages);
		$from = $curr_page - $offset;
		$to = $curr_page + $offset;
		$more = 0;
		if($page >= $pages) {
			$from = 2;
			$to = $pages-1;
		} else {
			if($from <= 1) {
				$to = $page-1;
				$from = 2;
			}  elseif($to >= $pages) {
				$from = $pages-($page-2);
				$to = $pages-1;
			}
			$more = 1;
		}
		$multipage .= '<a class="a1">'.$num.L('page_item').'</a>';
		if($curr_page>0) {
			$multipage .= ' <a href="'.pageurl($urlrule, $curr_page-1, $array).'" class="a1">'.L('previous').'</a>';
			if($curr_page==1) {
				$multipage .= ' <span>1</span>';
			} elseif($curr_page>6 && $more) {
				$multipage .= ' <a href="'.pageurl($urlrule, 1, $array).'">1</a>..';
			} else {
				$multipage .= ' <a href="'.pageurl($urlrule, 1, $array).'">1</a>';
			}
		}
		for($i = $from; $i <= $to; $i++) {
			if($i != $curr_page) {
				$multipage .= ' <a href="'.pageurl($urlrule, $i, $array).'">'.$i.'</a>';
			} else {
				$multipage .= ' <span>'.$i.'</span>';
			}
		}
		if($curr_page<$pages) {
			if($curr_page<$pages-5 && $more) {
				$multipage .= ' ..<a href="'.pageurl($urlrule, $pages, $array).'">'.$pages.'</a> <a href="'.pageurl($urlrule, $curr_page+1, $array).'" class="a1">'.L('next').'</a>';
			} else {
				$multipage .= ' <a href="'.pageurl($urlrule, $pages, $array).'">'.$pages.'</a> <a href="'.pageurl($urlrule, $curr_page+1, $array).'" class="a1">'.L('next').'</a>';
			}
		} elseif($curr_page==$pages) {
			$multipage .= ' <span>'.$pages.'</span> <a href="'.pageurl($urlrule, $curr_page, $array).'" class="a1">'.L('next').'</a>';
		} else {
			$multipage .= ' <a href="'.pageurl($urlrule, $pages, $array).'">'.$pages.'</a> <a href="'.pageurl($urlrule, $curr_page+1, $array).'" class="a1">'.L('next').'</a>';
		}
	}
	return $multipage;
}

/**
 * URL组装支持不同模式的路由 循环中不要使用效率底下的很
 *
 * @param string $url app/C/A 这样传值
 * @param array $params 附加的参数传数组
 * @param boolean $suffix 是否添加自定义后缀
 */
function U($url,$params=array(),$suffix=false) {
	$urlx = '';
    if(!defined('IN_ADMIN') && Core::load_config('core','url_model')> 0) {
    	$depr = Core::load_config('core','url_pathinfo_depr');
    	$tarr = explode('/', $url);
    	$route = Core::load_config('route','default');
    	if(!$tarr[1]) $url .= $depr.$route['controller'];
    	if(!$tarr[2]) $url .= $depr.$route['action'];
    	//生成PATH_INFO方式的url
        foreach ($params as $var=>$val) {
        	if($val !== '') $urlx .= $depr.$var.$depr.$val;
        }
        $url = $depr.$url.$urlx;
        if($suffix && Core::load_config('core','url_html_suffix')) $url .= Core::load_config('core','url_html_suffix');
    } else {
    	$tarr = explode('/', $url);
    	foreach ($tarr as $k=>$v) {
			if($k == 0)		  $urlx .= Core::load_config('core','var_application').'='.$v;
			elseif($k == 1)   $urlx .= '&'.Core::load_config('core','var_controller').'='.$v;
			elseif($k == 2)   $urlx .= '&'.Core::load_config('core','var_action').'='.$v;
		}
        $params =   http_build_query($params);
        $params = !empty($params) ? '&'.$params : '';
        $url = '?'.$urlx.$params;
    }
    return PHP_FILE.$url;
}

/**
 * 字符串加密、解密函数
 * @param	string	$txt		字符串
 * @param	string	$operation	ENCODE为加密，DECODE为解密，可选参数，默认为ENCODE，
 * @param	string	$key		密钥：数字、字母、下划线
 * @return	string
 */
function authcode($txt, $operation = 'ENCODE', $key = '') {
	$key	= $key ? $key : Core::load_config('core', 'auth_key');
	$txt	= $operation == 'ENCODE' ? (string)$txt : base64_decode($txt);
	$len	= strlen($key);
	$code	= '';
	for($i=0; $i<strlen($txt); $i++){
		$k		= $i % $len;
		$code  .= $txt[$i] ^ $key[$k];
	}
	$code = $operation == 'DECODE' ? $code : base64_encode($code);
	return $code;
}

/**
 * 自定义异常处理函数
 * @param string $msg
 * @param string $type
 * @param int $code
 */
function throw_exception($msg,$type='LeapsException',$code=0) {
    if(class_exists($type,false))
       throw new $type($msg,$code,true);
    else
       halt($msg);        // 异常类型不存在则输出错误信息字串
}

/**
 * 语言文件处理
 * @param	string		$language	标示符
 * @param	array		$pars	转义的数组,二维数组 ,'key1'=>'value1','key2'=>'value2',
 * @param	string		$applications 多个模块之间用半角逗号隔开，如：member,guestbook
 * @return	string		语言字符
 */
function L($language = 'NO_LANG',$pars = array(), $applications = '') {
	static $LANG = array();
	static $LANG_APPLICATIONS = array();
	if(!defined('LANG')) define('LANG', Core::load_config('core','lang'));
	if(!$LANG) {
		//加载框架语言包
		require_once CORE_PATH.'language'.DS.LANG.DS.'leaps.lang.php';
		require_once CORE_PATH.'language'.DS.LANG.DS.'core.lang.php';
		if(defined('ROUTE_APP') && file_exists(CORE_PATH.'language'.DS.LANG.DS.ROUTE_APP.'.lang.php')) require CORE_PATH.'language'.DS.LANG.DS.ROUTE_APP.'.lang.php';
	}
	if(!empty($applications)) {
		$applications = explode(',',$applications);
		foreach($applications AS $app) {
			if(!isset($LANG_APPLICATIONS[$app])) require CORE_PATH.'language'.DS.LANG.DS.$app.'.lang.php';
		}
	}
	if(!array_key_exists($language,$LANG)) {
		return $LANG['NO_LANG'].'['.$language.']';
	} else {
		$language = $LANG[$language];
		if($pars) {
			foreach($pars AS $_k=>$_v) {
				$language = str_replace('{'.$_k.'}',$_v,$language);
			}
		}
		return $language;
	}
}

/**
 * 显示错误信息
 * @param string $error 错误信息
 */
function halt($error) {
    $e = array();
    if(defined('DEV')){
        //调试模式下输出错误信息
        if(!is_array($error)) {
            $trace = debug_backtrace();
            $e['message'] = $error;
            $e['file'] = $trace[0]['file'];
            $e['class'] = $trace[0]['class'];
            $e['function'] = $trace[0]['function'];
            $e['line'] = $trace[0]['line'];
            $traceInfo='';
            $time = date("y-m-d H:i:m");
            foreach($trace as $t) {
                $traceInfo .= '['.$time.'] '.$t['file'].' ('.$t['line'].') ';
                $traceInfo .= $t['class'].$t['type'].$t['function'].'(';
                $traceInfo .= implode(', ', $t['args']);
                $traceInfo .=")<br/>";
            }
            $e['trace']  = $traceInfo;
        }else {
            $e = $error;
        }
        // 包含异常页面模板
        include CORE_PATH.'tpl'.DS.'exception.tpl.php';
    } else {
        //否则定向到错误页面
        $error_page =   Core::load_config('core','error_page');
        if(!empty($error_page)){
            redirect($error_page);
        }else {
            if(Core::load_config('core','show_error_msg'))
                $e['message'] =  is_array($error) ? $error['message'] : $error;
            else
                $e['message'] = Core::load_config('core','error_message');
            // 包含异常页面模板
            include CORE_PATH.'tpl'.DS.'exception.tpl.php';
        }
    }
    exit;
}

/**
 * URL重定向
 * @param string $url
 * @param int $time
 * @param string $msg
 */
function redirect($url,$time=0,$msg='') {
    //多行URL地址支持
    $url = str_replace(array("\n", "\r"), '', $url);
    if(empty($msg))
        $msg    =   "系统将在{$time}秒之后自动跳转到{$url}！";
    if (!headers_sent()) {
        // redirect
        if(0===$time) {
            header("Location: ".$url);
        }else {
            header("refresh:{$time};url={$url}");
            echo($msg);
        }
        exit();
    } else {
        $str    = "<meta http-equiv='Refresh' content='{$time};URL={$url}'>";
        if($time!=0) $str   .=   $msg;
        exit($str);
    }
}

/**
 * 写入日志
 * @param string $name 日志名称，如果带‘/’则生成文件夹
 * @param string $value 日志内容
 */
function wlog($name, $value) {
	error_log($value."\n", 3, CACHE_PATH.'log'.DS.$name);
}

/**
 * 设置和获取统计数据
 * @param string $key 要统计的项
 * @param int $step  递加的值
 * @return int 如果递加的值为空返回目前该项统计到的次数
 */
function N($key,$step = 0) {
    static $_num = array();
    if(!isset($_num[$key])) {
        $_num[$key]  =  0;
    }
    if(empty($step))
        return $_num[$key];
    else
        $_num[$key]  =  $_num[$key]+(int)$step;
}

/**
 * 区分大小写的文件存在判断
 * @param $string 需要处理的文件路径
 * @return boolean 存在返回true,否则返回 false
 */
function file_exists_case($filename) {
    if(is_file($filename)){
        if(IS_WIN &&  defined('APP_FILE_CASE')){
            if(basename(realpath($filename)) != basename($filename)) return false;
        }
        return true;
    }
    return false;
}

/**
 * 安全过滤函数
 * @param $string 要过滤的字符串
 * @return string 返回处理过的字符串
 */
function safe_replace($string) {
	$string = str_replace('%20','',$string);
	$string = str_replace('%27','',$string);
	$string = str_replace('%2527','',$string);
	$string = str_replace('*','',$string);
	$string = str_replace('"','&quot;',$string);
	$string = str_replace("'",'',$string);
	$string = str_replace('"','',$string);
	$string = str_replace(';','',$string);
	$string = str_replace('<','&lt;',$string);
	$string = str_replace('>','&gt;',$string);
	$string = str_replace("{",'',$string);
	$string = str_replace('}','',$string);
	return $string;
}

/**
 * 使用htmlspecialchars处理字符串或数组
 * @param $obj 需要处理的字符串或数组
 * @return mixed 返回经htmlspecialchars处理过的字符串或数组
 */
function new_htmlspecialchars($string) {
	if(!is_array($string))
		return htmlspecialchars($string);
	foreach($string as $key => $val)
		$string[$key] = new_htmlspecialchars($val);
	return $string;
}

/**
 * 使用addslashes处理字符串或数组
 * @param $string 需要处理的字符串或数组
 * @return mixed  返回经addslashes处理过的字符串或数组
 */
function new_addslashes($string) {
	if(!is_array($string))
		return addslashes($string);
	foreach($string as $key => $val)
		$string[$key] = new_addslashes($val);
	return $string;
}

/**
 * 使用stripslashes处理字符串或数组
 * @param $string 需要处理的字符串或数组
 * @return mixed  返回经stripslashes处理过的字符串或数组
 */
function new_stripslashes($string) {
	if(!is_array($string))
		return stripslashes($string);
	foreach($string as $key => $val)
		$string[$key] = new_stripslashes($val);
	return $string;
}

/* End of file global.func.php */