<?php
// +----------------------------------------------------------------------
// | Leaps PHP Framework
// +----------------------------------------------------------------------
// | Copyright (c) 2010 http://www.newsteng.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: Silence <xutongle@gmail.com>
// +----------------------------------------------------------------------
// $Id$

/**
 +------------------------------------------------------------------------------
 * leaps.php Leaps 框架入口
 +------------------------------------------------------------------------------
 * $Id$
 +------------------------------------------------------------------------------
 */

/**
 * 记录加载和运行时间
 * @param string $start
 * @param string $end
 * @param int $dec
 */
function G($start,$end='',$dec=3) {
    static $_info = array();
    if(!empty($end)) { // 统计时间
        if(!isset($_info[$end])) $_info[$end]   =  microtime(TRUE);
        return number_format(($_info[$end]-$_info[$start]),$dec);
    } else { // 记录时间
        $_info[$start]  =  microtime(TRUE);
    }
}

G('begin_time');//记录开始运行时间
define('IN_LEAPS', true);//设置入口标记
define('LEAPS_VERSION', '0.0.2');//框架版本
define('LEAPS_RELEASE', '20110527');
define('DEV', true);//开发模式
define('MEMORY_LIMIT_ON',function_exists('memory_get_usage'));//记录内存初始使用
define('IS_WIN',strstr(PHP_OS, 'WIN') ? 1 : 0 );//定义操作系统类型
define('IS_CGI',substr(PHP_SAPI, 0,3)=='cgi' ? 1 : 0 );//是否是CGI模式
define('DS',DIRECTORY_SEPARATOR);//定义DIRECTORY_SEPARATOR简写
if(!defined('BASE_PATH')) define('BASE_PATH', dirname($_SERVER['SCRIPT_FILENAME']).DS);//定义根目录绝对路径
define('CORE_PATH', dirname(__FILE__).DS);//定义核心目录
define('CACHE_PATH', BASE_PATH.'cache'.DS);//定义缓存目录
define('SITE_PROTOCOL', isset($_SERVER['SERVER_PORT']) && $_SERVER['SERVER_PORT'] == '443' ? 'https://' : 'http://');//设置端口
define('SITE_HOST', (isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : ''));//设置主机名
define('HTTP_REFERER', isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '');//设置来路
define('TIME', time());//设置系统时间避免重复使用time();
//当前文件名
if(IS_CGI) {//CGI/FASTCGI模式下
    $_temp  = explode('.php',$_SERVER["PHP_SELF"]);
    define('_PHP_FILE_',  rtrim(str_replace($_SERVER["HTTP_HOST"],'',$_temp[0].'.php'),'/'));
} else {
    define('_PHP_FILE_',    rtrim($_SERVER["SCRIPT_NAME"],'/'));
}
define('WEB_PATH',Core::load_config('core','web_path'));//定义网站根路径
define('APP_PATH',Core::load_config('core','app_path'));//设置网站访问地址
if(MEMORY_LIMIT_ON)	$GLOBALS['_startusemems'] = memory_get_usage();//记录内存初始使用
if (function_exists("set_time_limit") == TRUE AND @ini_get("safe_mode") == 0) @set_time_limit(300);//设置脚本执行时间限制
Core::load_core_func('global');//加载核心函数库
Core::load_core_func('extention');//加载用户自定义函数库
Core::auto_load_func();//自动加载函数库
if(function_exists('date_default_timezone_set')) date_default_timezone_set(Core::load_config('core','timezone'));
set_error_handler(array('Core','Error'));
set_exception_handler(array('Core','Exception'));
define('CHARSET' ,Core::load_config('core','charset','UTF-8'));//定义字符集

if(!get_magic_quotes_gpc()) {//判断字符串转义
	$_POST = new_addslashes($_POST);
	$_GET = new_addslashes($_GET);
	$_REQUEST = new_addslashes($_REQUEST);
	$_COOKIE = new_addslashes($_COOKIE);
}
header('Content-type: text/html; charset='.CHARSET);//输出页面字符集
define('JS_PATH',Core::load_config('core','js_path'));//CDN JS路径
define('CSS_PATH',Core::load_config('core','css_path'));//CDN CSS路径
define('IMG_PATH',Core::load_config('core','img_path'));//CDN IMG路径
define('SKIN_PATH',Core::load_config('core','app_path').'static/skin/'.Core::load_config('core','tpl_css').'/');
//Gzip
if(Core::load_config('core','gzip') && function_exists('ob_gzhandler')) {
	ob_start('ob_gzhandler');
} else {
	ob_start();
}
Core::load_core_class('cookie','',0);//加载Cookie处理类
Core::load_core_class('exceptions','',0);//加载异常处理类
Core::load_core_class('model','',0);//加载模型基类
Core::import(BASE_PATH.'config'.DS.'hooks.php');//加载用户自定义钩子
if(Core::load_config('core','firephp')) Core::load_core_class('FirePHP','', 0);//判断是否启用调试
access_log();//记录访问日志
/**
 *  核心类
 * @author Administrator
 *
 */
class Core {
	private static $_config = array(),$_func = array(),$_class = array(),$_file;

	/**
	 * 初始化应用程序
	 */
	public static function run() {
		return self::load_core_class('application');
	}

	/**
	 * 加载应用类方法
	 * @param string $classname 类名
	 * @param string $app 应用
	 * @param intger $initialize 是否初始化
	 */
	public static function load_app_class($classname, $app = '', $initialize = 1) {
		$app = empty($app) && defined('ROUTE_APP') ? ROUTE_APP : $app;
		if (empty($app)) return false;
		return self::_load_class($classname,BASE_PATH.'application'.DIRECTORY_SEPARATOR.$app.DIRECTORY_SEPARATOR.'class', $initialize);
	}

	/**
	 * 加载应用函数库
	 * @param string $func 函数库名
	 * @param string $m 应用名
	 */
	public static function load_app_func($func, $app = '') {
		$app = empty($app) && defined('ROUTE_APP') ? ROUTE_APP : $app;
		if (empty($app)) return false;
		return self::_load_func($func, BASE_PATH.'application'.DIRECTORY_SEPARATOR.$app.DIRECTORY_SEPARATOR.'function');
	}

	/**
	 * 加载系统类方法
	 * @param string $classname 类名
	 * @param string $path 扩展地址
	 * @param intger $initialize 是否初始化
	 */
	public static function load_core_class($classname, $path = '', $initialize = 1) {
			return self::_load_class($classname, $path, $initialize);
	}

	/**
	 * 加载系统的函数库
	 * @param string $func 函数库名
	 */
	public static function load_core_func($func) {
		return self::_load_func($func);
	}

	/**
	 * 加载数据模型
	 * @param string $classname 类名
	 */
	public static function load_model($classname) {
		return self::_load_class($classname,CORE_PATH.'model');
	}

	/**
	 * 自动加载autoload目录下函数库
	 * @param string $func 函数库名
	 */
	public static function auto_load_func($path='') {
		return self::_auto_load_func($path);
	}

	/**
	 * 加载函数库
	 * @param string $func 函数库名
	 * @param string $path 地址
	 */
	private static function _load_func($func, $path = ''){
		if (empty($path)) $path = CORE_PATH.'function';
		$path .= DIRECTORY_SEPARATOR.$func.'.func.php';
		$key = md5($path);
		if (isset(self::$_func[$key])) return true;
		if (file_exists($path)) {
			include $path;
		} else {
			self::$_func[$key] = false;
			throw_exception($path.L('_FILE_NOT_EXIST_'));
			return false;
		}
		self::$_func[$key] = true;
		return true;
	}

	/**
	 * 加载函数库
	 * @param string $func 函数库名
	 * @param string $path 地址
	 */
	private static function _auto_load_func($path = '') {
		if (empty($path)) $path = 'function'.DIRECTORY_SEPARATOR.'autoload';
		$path .= DIRECTORY_SEPARATOR.'*.func.php';
		$auto_funcs = glob(CORE_PATH.$path);
		if(!empty($auto_funcs) && is_array($auto_funcs)) {
			foreach($auto_funcs as $func_path) {
				include $func_path;
			}
		}
	}

	/**
	 * 加载类文件函数
	 * @param string $classname 类名
	 * @param string $path 扩展地址
	 * @param intger $initialize 是否初始化
	 */
	private static function &_load_class($classname, $path = '', $initialize = 1) {
		if (empty($path)) $path = CORE_PATH.'class';
		$key = md5($path.$classname);
		if (isset(self::$_class[$key])) {
			if (!empty(self::$_class[$key])) {
				return self::$_class[$key];
			} else {
				return true;
			}
		}
		if (file_exists($path.DIRECTORY_SEPARATOR.$classname.'.class.php')) {
			include $path.DIRECTORY_SEPARATOR.$classname.'.class.php';
			if ($initialize) {
				self::$_class[$key] = new $classname;
			} else {
				self::$_class[$key] = true;
			}
			return self::$_class[$key];
		} else {
			throw_exception(CORE_PATH.$path.DIRECTORY_SEPARATOR.$classname.'.class.php'.L('_CLASS_NOT_EXIST_'));
			return false;
		}
	}

	/**
	 * 加载配置文件
	 * @param string $file 配置文件
	 * @param string $key  要获取的配置荐
	 * @param string $default  默认配置。当获取配置项目失败时该值发生作用。
	 * @param boolean $reload 强制重新加载。
	 */
	public static function load_config($file, $key = '', $default = '', $reload = false) {
		if (!$reload && isset(self::$_config[$file])) {
			if (empty($key)) {
				return self::$_config[$file];
			} elseif (isset(self::$_config[$file][$key])) {
				return self::$_config[$file][$key];
			} else {
				return $default;
			}
		}
		$path = BASE_PATH.'config'.DIRECTORY_SEPARATOR.$file.'.php';
		if (file_exists($path)) {
			self::$_config[$file] = include $path;
		}
		if (empty($key)) {
			return self::$_config[$file];
		} elseif (isset(self::$_config[$file][$key])) {
			return self::$_config[$file][$key];
		} else {
			return $default;
		}
	}

	/**
	 * 导入文件不区分大小写
	 * @param string $filename 要导入的文件
	 */
	public static function import($filename) {
    	$filename = realpath($filename);
    	$key = md5($filename);
    	if (!isset(self::$_file[$key])) {
        	if (file_exists($filename)) {
            	require $filename;
            	self::$_file[$key] = true;
        	} else {
            	self::$_file[$key] = false;
        	}
    	}
    	return self::$_file[$key];
	}

	/**
	 * Session初始化
	 */
	public static function session_start() {
		$session_storage = 'session_'.self::load_config('core','session_storage');
		self::_load_class($session_storage,CORE_PATH.'class'.DS.'session');
	}

	/**
     * 自定义异常处理
     *
     * @param mixed $e 异常对象
     */
    static public function Exception($e) {
    	if(self::load_config('core','firephp')) fb($e);
        if(!is_ajax()) halt($e->__toString());
    }

	/**
     * 自定义错误处理
     *
     * @param int $errno 错误类型
     * @param string $errstr 错误信息
     * @param string $errfile 错误文件
     * @param int $errline 错误行数
     * @return void
     */
    static public function Error($errno, $errstr, $errfile, $errline) {
      switch ($errno) {
          case E_ERROR:
          case E_USER_ERROR:
            $error_str = "[$errno] $errstr ".basename($errfile)." 第 $errline 行.";
            halt($error_str);
            break;
          case E_STRICT:
          case E_USER_WARNING:
          case E_USER_NOTICE:
          default:
            $error_str = "[$errno] $errstr ".basename($errfile)." 第 $errline 行.";
            if(self::load_config('core','errorlog')) wlog('ErrorLog.log', $error_str);
            break;
      }
    }
}
G('load_time');//记录加载文件时间
/* End of file leaps.php */